<?php

/* Defining the ToDo class */
  
     


class ToDo{

	/* An array that stores the todo item data: */
	
	private $data;
	
	/* The constructor */
	public function __construct($par){
		if(is_array($par))
			$this->data = $par;
      // Fonctions

	}
	
	/*
		This is an in-build "magic" method that is automatically called 
		by PHP when we output the ToDo objects with echo. 
	*/
		
	public function __toString(){
		
		// The string we return is outputted by the echo statement
		
		return '
			<li id="todo-'.$this->data['id'].'" class="todo">
			
				<div class="text">'.$this->data['text'].'</div>

                <div class="confirm">
                    <a class="saveChanges" href=""><abbr title="Save"><img src="./img/save.png" width="16" height="16"></abbr></a>
                    <a class="discardChanges" href=""><abbr title="Cancel"><img src="./img/cancel.png" width="16" height="16"></abbr></a>
                </div>
				
				<div class="actionsToDo">
					<a href="" class="editToDo"><abbr title="Modifier la note"><img src="./img/edit.png" width="16" height="16" /></abbr></a>
					<a href="" class="deleteToDo"><abbr title="Supprimer la note"><img src="./img/delete.png" width="16" height="16" /></abbr></a>
				</div>
				
			</li>';
	}
	
	
	/*
		The following are static methods. These are available
		directly, without the need of creating an object.
	*/
	
	
	
	/*
		The edit method takes the ToDo item id and the new text
		of the ToDo. Updates the database.
	*/
		
	public static function edit($id, $text){
		
		$text = self::esc($text);
		if(!$text) throw new Exception("Wrong update text!");
		
		mysql_query("	UPDATE todo
						SET text='".$text."'
						WHERE id=".$id
					);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}
	
	/*
		The delete method. Takes the id of the ToDo item
		and deletes it from the database.
	*/
	
	public static function delete($id){
		
		mysql_query("DELETE FROM todo WHERE id=".$id);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Impossible de supprimer cette note!");
	}
	
	/*
		The rearrange method is called when the ordering of
		the todos is changed. Takes an array parameter, which
		contains the ids of the todos in the new order.
	*/
	
	public static function rearrange($key_value){
		
		$updateVals = array();
		foreach($key_value as $k=>$v)
		{
			$strVals[] = 'WHEN '.(int)$v.' THEN '.((int)$k+1).PHP_EOL;
		}
		
		if(!$strVals) throw new Exception("No data!");
		
		// We are using the CASE SQL operator to update the ToDo positions en masse:
		
		mysql_query("	UPDATE todo SET position = CASE id
						".join($strVals)."
						ELSE position
						END");
		
		if(mysql_error($GLOBALS['link']))
			throw new Exception("Error updating positions!");
	}
	
	/*
		The createNew method takes only the text of the todo,
		writes to the databse and outputs the new todo back to
		the AJAX front-end.
	*/
	
	public static function createNew($list_id,$text){

		$text = self::esc($text);
		if(!$text) throw new Exception("Wrong input data!");
		
		$posResult = mysql_query("SELECT MAX(position)+1 FROM todo WHERE list_id = $list_id");
		
		if(mysql_num_rows($posResult))
			list($position) = mysql_fetch_array($posResult);

		if(!$position) $position = 1;

		mysql_query("INSERT INTO todo SET text='".$text."', position = ".$position.", list_id = ".$list_id);

		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Error inserting TODO!");
		
		// Creating a new ToDo and outputting it directly:
		
		echo (new ToDo(array(
			'id'	=> mysql_insert_id($GLOBALS['link']),
			'text'	=> $text
		)));
		
		exit;
	}
	
	/*
		The changeList method takes the ToDo item id and the new list ID
		of the ToDo. Updates the database.
	*/
		
	public static function changeList($id, $list_id){
		
		if(!$list_id) throw new Exception("Wrong update text!");
		
		mysql_query("	UPDATE todo
						SET list_id='".$list_id."'
						WHERE id=".$id
					);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}

	/*
		The newList method creates a new ToDo list
		and updates the database.
	*/
		
	public static function newList($name, $project_id){
		
		if(!$name) throw new Exception("Wrong update text!");

		mysql_query("INSERT INTO lists SET name='".$name."', position = '61x14x1000', project_id = $project_id");
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
		
		$listID = mysql_insert_id();

        echo '<div id="List-'.$listID.'" class="listBox" style="left:61px;top:14px;z-index:1000">'."\n";
        echo '        <a class="newToDo" onclick=myCallback(this) href="">'."\n";
        echo '        	<abbr title="Ajouter une Note"><img src="./img/add.png" width="16" height="16" /></abbr>'."\n";
        echo '        </a>'."\n";
		echo '	<span class="data">'.$listID.'</span>'."\n";
        echo '       <div class="listTitle">'."\n";
        echo '            <div class="listName">'.$name.'</div>'."\n";
        echo '        <div class="confirmList">'."\n";
        echo '            <a class="saveChanges" href=""><abbr title="Save"><img src="./img/save.png" width="16" height="16"></abbr></a>'."\n";
        echo '            <a class="discardChanges" href=""><abbr title="Cancel"><img src="./img/cancel.png" width="16" height="16"></abbr></a>'."\n";
        echo '        </div>'."\n";
        echo '            <div class="actionsList">'."\n";
        echo '                <a href="" class="editList"><abbr title="Edit List Title"><img src="./img/edit.png" width="16" height="16" /></abbr></a>'."\n";
        echo '                <a href="" class="deleteList"><abbr title="Delete List"><img src="./img/delete.png" width="16" height="16" /></abbr></a>'."\n";
        echo '            </div>'."\n";
        echo '        </div>'."\n";
       	echo '		<ul class="todoList">'."\n";
        echo '            <div class="listHead"><abbr title="Collapse/Expand List">';
		echo '				  <img id="List-'.$listID.'"  class="collapse" src="./img/collapse.png" width="16" height="16" /></abbr>';
		echo '			  </div>'."\n";
        echo '            <div id="List-'.$listID.'" class="listBody">'."\n";
        echo '            </div>'."\n";
		echo '		</ul>'."\n";
		echo '</div>'."\n";

		exit;
	}

	/*
		The listPosition method takes the List id and the 
		x, y and z coordinates of the list and updates the database.
	*/
		
	public static function listPosition($id,$x,$y,$z){
		
		mysql_query("UPDATE lists SET position='".$x."x".$y."x".$z."' WHERE list_id=".$id);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}

	/*
		The editList method takes the List id and the new name
		of the list and updates the database.
	*/
		
	public static function editList($id, $text){
		
		$text = self::esc($text);
		if(!$text) throw new Exception("Wrong update text!");

		mysql_query("	UPDATE lists
						SET name='".$text."'
						WHERE list_id=".$id
					);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}

	/*
		The deleteList method. Takes the id of the List item
		and deletes it from the database.  Then matches all ToDo items
		and deletes them from the database.
	*/
	
	public static function deleteList($id){
		
		mysql_query("DELETE FROM lists WHERE list_id=".$id);
		mysql_query("DELETE FROM todo WHERE list_id=".$id);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't delete item!");
	}

	/*
		The listToggleExpanded method checks the current setting, 
		toggles it and updates the database.
	*/
		
	public static function listToggleExpanded($id){
		
		$query = mysql_query("Select expanded from lists WHERE list_id=".$id);
		while($row = mysql_fetch_assoc($query)){
			$expanded = $row['expanded'];
		}
		
		if($expanded == 0) mysql_query("UPDATE lists set expanded = 1 WHERE list_id=".$id);
		if($expanded == 1) mysql_query("UPDATE lists set expanded = 0 WHERE list_id=".$id);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}

	/*
		The listExpanded method sets the list to expaned 
		and updates the database.
	*/
		
	public static function listExpanded($id){
		
		mysql_query("UPDATE lists set expanded = 1 WHERE list_id=".$id);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}

	/*
		The newTab method creates a new tab
		and updates the database.
	*/
		
	public static function newProject($name){
		
		if(!$name) throw new Exception("Wrong update text!");
    
    $password2=    $_SESSION['password'] ;
		mysql_query("INSERT INTO projects SET uid ='".$password2."' ,  name='".$name."'");
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
		
		$project_id = mysql_insert_id();
		
		// set the position of the newly created tab to its id so that it is last in the order
		mysql_query("UPDATE projects SET position=".$project_id." WHERE project_id=".$project_id);
		
		echo $project_id;

		exit;
	}

	/*
		The editProject method takes the Project id and the new name
		of the project and updates the database.
	*/
		
	public static function editProject($id, $text){
		
		$text = self::esc($text);
		if(!$text) throw new Exception("Wrong update text!");

		mysql_query("	UPDATE projects
						SET name='".$text."'
						WHERE project_id=".$id
					);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Couldn't update item!");
	}

	/*
		The deleteProject method. Takes the id of the current Project
		and deletes it from the database.  Then matches all Lists that
		belong to that project 	and deletes them from the database.
	*/
	
	public static function deleteProject($id){
		
		$query = mysql_query("Select list_id from lists WHERE project_id=".$id);
		while($row = mysql_fetch_assoc($query)){

			mysql_query("DELETE FROM todo WHERE list_id=".$row['list_id']);
			
		}
		
		mysql_query("DELETE FROM lists WHERE project_id=".$id);
		mysql_query("DELETE FROM projects WHERE project_id=".$id);
		
		if(mysql_affected_rows($GLOBALS['link'])!=1)
			throw new Exception("Impossible de supprimer cette note!");
	}

	/*
		The rearrangeProjects method is called when the ordering of
		the tabs is changed. Takes an array parameter, which
		contains the ids of the tabs in the new order.
	*/
	
	public static function rearrangeProjects($key_value){
		
		$updateVals = array();
		foreach($key_value as $k=>$v)
		{
			$strVals[] = 'WHEN '.(int)$v.' THEN '.((int)$k+1).PHP_EOL;
		}
		
		if(!$strVals) throw new Exception("No data!");
		
		// We are using the CASE SQL operator to update the ToDo positions en masse:
		
		mysql_query("	UPDATE projects SET position = CASE project_id
						".join($strVals)."
						ELSE position
						END");
		
		if(mysql_error($GLOBALS['link']))
			throw new Exception("Error updating positions!");
	}

	/*
		A helper method to sanitize a string:
	*/
	
	public static function esc($str){
		
		if(ini_get('magic_quotes_gpc'))
			$str = stripslashes($str);
		
		return mysql_real_escape_string(strip_tags($str));
	}
	
} // closing the class definition

?>